Package org.zkoss.stateless.sul

## Interface IScrollview<I extends IAnyGroup>

- All Superinterfaces:
    `IAnyGroup<IScrollview<I>>`, `IChildable<IScrollview<I>,​I>`, `IComponent<IScrollview<I>>`, `IHtmlBasedComponent<IScrollview<I>>`, `IXulElement<IScrollview<I>>`

      public interface IScrollview<I extends IAnyGroup>
      extends IXulElement<IScrollview<I>>, IAnyGroup<IScrollview<I>>, IChildable<IScrollview<I>,​I>

  Immutable `Scrollview` component

  A container that can scroll containing elements on touch devices.

  Note: if using this component not in touch devices, it will treat as a simple DIV element, no functions at all.

  ### Support @Action

  Name | Action Type
  --- | ---
  onScroll | ActionData: `ScrollData` In mobile devices: Denotes that the content of a scrollable component has been scrolled by the user. Notice that you can check if it is scrolled outside/inside boundaries by invoking getOutOfBound method in the ScrollEvent. In desktop: This action will be triggered when users scroll all the way to the top or to the end of the page.
  onScrolling | ActionData: `ScrollData` Denotes that the user is scrolling a scrollable component.

  Author:
    katherine
  See Also:
    `Scrollview`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IScrollview.Builder<I extends IAnyGroup>` | Builds instances of type `IScrollview`.
    `static class` | `IScrollview.Orient` | Specifies the orient of `IScrollview` component
    `static class` | `IScrollview.Updater` | Builds an updater of type `IScrollview` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IScrollview<IAnyGroup>` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getOrient()` | Returns current orient (horizontal or vertical).
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `static <I extends IAnyGroup> IScrollview<I>` | `of​(I... children)` | Returns the instance with the given any group children.
    `static <I extends IAnyGroup> IScrollview<I>` | `of​(java.lang.Iterable<? extends I> children)` | Returns the instance with the given any group children.
    `static <I extends IAnyGroup> IScrollview<I>` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `static <I extends IAnyGroup> IScrollview<I>` | `ofSize​(java.lang.String width, java.lang.String height)` | Returns the instance with the given size, width and height.
    `IScrollview<I>` | `withOrient​(java.lang.String orient)` | Returns a copy of `this` immutable component with the specified `orient`.
    `default IScrollview<I>` | `withOrient​(IScrollview.Orient orient)` | Returns a copy of `this` immutable component with the specified `orient`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IScrollview<IAnyGroup> DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zkmax.layout.Scrollview"`

      Specified by:
        `getWidgetClass` in interface `IComponent<I extends IAnyGroup>`

    - #### getOrient

          default java.lang.String getOrient()

      Returns current orient (horizontal or vertical).

      Default: `"vertical"`

    - #### withOrient

          IScrollview<I> withOrient​(java.lang.String orient)

      Returns a copy of `this` immutable component with the specified `orient`.

      Sets the orient of component

      Parameters:
        `orient` - Either `"horizontal"` or `"vertical"`

        Default: `"vertical"`.

      Returns:
        A modified copy of the `this` object

    - #### withOrient

          default IScrollview<I> withOrient​(IScrollview.Orient orient)

      Returns a copy of `this` immutable component with the specified `orient`.

      Sets the orient of component

      Parameters:
        `orient` - Either `"horizontal"` or `"vertical"`

        Default: `"vertical"`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static <I extends IAnyGroup> IScrollview<I> of​(java.lang.Iterable<? extends I> children)

      Returns the instance with the given any group children.
      Parameters:
        `children` - The children belong to any group
      See Also:
        `IAnyGroup`

    - #### of

          static <I extends IAnyGroup> IScrollview<I> of​(I... children)

      Returns the instance with the given any group children.
      Parameters:
        `children` - The children belong to any group
      See Also:
        `IAnyGroup`

    - #### ofSize

          static <I extends IAnyGroup> IScrollview<I> ofSize​(java.lang.String width,
                                                             java.lang.String height)

      Returns the instance with the given size, width and height.
      Parameters:
        `width` - The width of the component
        `height` - The height of the component

    - #### ofId

          static <I extends IAnyGroup> IScrollview<I> ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component